#include <support/SupportDefs.h>
#if 0
typedef unsigned char uint8;
typedef unsigned short int uint16;
typedef unsigned long int uint32;
#endif

struct ParsedConfigEntryTuple_t
{
	/* TPCE_INDX */
	uint8	Intface, Default, ConfigIndex;
	
	/* TPCE_IF */
	uint8	MWaitReq, ReadyAct, WPAct, BVDAct, IFType;
	
	/* TPCE_FS */
	uint8	PowerSel, TimingSel, IOSpaceSel, IRQSel, MemSpaceSel, MiscSel;
	
	/* TPCE_PD */
	struct PwrDesc_t
	{
		float	NomV, MinV, MaxV, StaticI, AvgI, PeakI, PdwnI;
	} Vcc, Vpp1, Vpp2;
	
	/* TPCE_TD */
	uint8	WaitScale, ReadyScale, RsvScale;
	
	/* TPCE_IO */
	uint8	IOAddrLines, Bus16_8, IORange;
	uint8	IOAddrRanges, IOAddrSize, IOLenSize;
	struct
	{
		uint32	Start;
		uint32	Len;
	} IOAddrRange [16];
	
	/* TPCE_IR */
	uint8	Share, Pulse, Level, Mask, Vend, BErr, IOCk, NMI;
	uint8	IRQN;
	uint16	IRQMask;
	
	/* TPCE_MS */
	uint8	MemWins, MemLenSize, MemAddrSize, HostAddr;
	struct
	{
		uint32	Len;
		uint32	CardAddr;
		uint32	HostAddr;
	} WinDesc [8];
	
	/* TPCE_MI */
	uint8	MaxTwinCards, Audio, ReadOnly, PwrDown;
	uint8	DMAReqSig, DMAWidth;
	uint8	ThermalMajor, ThermalMinor;
};

int ParseConfigEntryTuple (uint8 *, int, struct ParsedConfigEntryTuple_t *);
